﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
#DesignerProperty: Key: BallColor, DisplayName: Bone Color, FieldType: Color, DefaultValue: 0xFFFFFFFF
#DesignerProperty: Key: Color, DisplayName: Color, FieldType: Color, DefaultValue: 0xFFC8C6C9
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFF5E4674
#DesignerProperty: Key: Duration, DisplayName: Duration, FieldType: Int, DefaultValue: 2000

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private clr As Int = 0xFF87FF36
	Private BackgroundColor As Int = 0xFF5E4674
	Private BallColor As Int = 0xFFC8C6C9
	Private index As Int
	Private cvs As B4XCanvas
	Private duration As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mBase.Tag=Me
	clr = xui.PaintOrColorToColor(Props.Get("Color"))
	BackgroundColor = xui.PaintOrColorToColor(Props.Get("BackgroundColor"))
	BallColor = xui.PaintOrColorToColor(Props.Get("BallColor"))
	
	Dim duration As Int = Props.Get("Duration")
	
	cvs.Initialize(mBase)
	MainLoop
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	cvs.Resize(Width, Height)
	MainLoop
End Sub

Private Sub MainLoop
	index = index + 1
	Dim MyIndex As Int = index
	Dim n As Long = DateTime.Now
	Do While MyIndex = index
		Dim progress As Float = (DateTime.Now - n) / duration
		progress = progress - Floor(progress)
		cvs.ClearRect(cvs.TargetRect)
		Draw(progress)
		cvs.Invalidate
		Sleep(30)
	Loop
End Sub

Public Sub Show
	mBase.Visible = True
	MainLoop
End Sub

Public Sub Hide
	mBase.Visible = False
	index = index + 1
End Sub

Private Sub Draw(Progress As Float)
	Dim Spss As Int = Min(mBase.Width,mBase.Height)
	Dim CatWidth As Int = Spss/2
	Dim Xeye1 As Int = cvs.TargetRect.CenterX-(CatWidth*0.25)
	Dim Xeye2 As Int = cvs.TargetRect.CenterX+(CatWidth*0.25)
	Dim Yeye As Int = cvs.TargetRect.Centery-(CatWidth*0.10)
	Dim Rec As B4XRect
	Dim rx As Float
	Dim ry As Float
	
	cvs.DrawRect(cvs.TargetRect,BackgroundColor,True,1dip)
	'cat face
	Rec.Initialize(cvs.TargetRect.CenterX-CatWidth/2,cvs.TargetRect.CenterY-CatWidth/2,cvs.TargetRect.CenterX+CatWidth/2,cvs.TargetRect.CenterY+CatWidth/2)
	Dim Path As B4XPath
	Path.InitializeRoundedRect(Rec,CatWidth/2.5)
	cvs.DrawPath(Path,clr,True,1DIP)
	
	'EARS
	cvs.DrawCircle(cvs.TargetRect.CenterX-(CatWidth*0.5),cvs.TargetRect.Centery-(CatWidth*0.40),CatWidth*0.20,clr,True,1dip)
	cvs.DrawCircle(cvs.TargetRect.CenterX+(CatWidth*0.5),cvs.TargetRect.Centery-(CatWidth*0.40),CatWidth*0.20,clr,True,1dip)
	
	'EYES
	cvs.DrawCircle(Xeye1,Yeye,CatWidth*0.20,xui.Color_White,True,1dip)
	cvs.DrawCircle(Xeye2,Yeye,CatWidth*0.20,xui.Color_White,True,1dip)
	
	'nose
	Path.InitializeArc(cvs.TargetRect.CenterX,cvs.TargetRect.CenterY,CatWidth/7,0,180)
	cvs.DrawPath(Path,BackgroundColor,True,1DIP)
	
	' mouth
	cvs.DrawLine(cvs.TargetRect.CenterX,cvs.TargetRect.CenterY,cvs.TargetRect.CenterX,cvs.TargetRect.CenterY+CatWidth/4,BackgroundColor,4dip)
	Path.InitializeArc(cvs.TargetRect.CenterX,cvs.TargetRect.CenterY+CatWidth/4,CatWidth/10,0,180)
	Path.LineTo(cvs.TargetRect.CenterX,cvs.TargetRect.CenterY+CatWidth/4)
	cvs.DrawPath(Path,BackgroundColor,False,4dip)
	
	' pupuils
	rx = CatWidth* 0.12 * Sin(Progress * 2 * cPI)
	ry = CatWidth* 0.12 * Cos(Progress * 2 * cPI)
	cvs.DrawCircle(Xeye1+rx,Yeye+ry,CatWidth*0.05,BackgroundColor,True,1dip)
	cvs.DrawCircle(Xeye2+rx,Yeye+ry,CatWidth*0.05,BackgroundColor,True,1dip)
	
	'  Bone
	rx = CatWidth* 1 * Sin((Progress-0.02) * 2 * cPI)
	ry = CatWidth* 0.9 * Cos((Progress-0.02) * 2 * cPI)
	cvs.DrawCircle(cvs.TargetRect.CenterX+rx,cvs.TargetRect.CenterY+ry,8dip,BallColor,True,1dip)
	rx = CatWidth* 0.9 * Sin((Progress-0.02) * 2 * cPI)
	ry = CatWidth* 0.8 * Cos((Progress-0.02) * 2 * cPI)
	cvs.DrawCircle(cvs.TargetRect.CenterX+rx,cvs.TargetRect.CenterY+ry,8dip,BallColor,True,1dip)
	
	
	rx = CatWidth* 1 * Sin((Progress+0.02) * 2 * cPI)
	ry = CatWidth* 0.9 * Cos((Progress+0.02) * 2 * cPI)
	cvs.DrawCircle(cvs.TargetRect.CenterX+rx,cvs.TargetRect.CenterY+ry,8dip,BallColor,True,1dip)
	rx = CatWidth* 0.9 * Sin((Progress+0.02) * 2 * cPI)
	ry = CatWidth* 0.8 * Cos((Progress+0.02) * 2 * cPI)
	cvs.DrawCircle(cvs.TargetRect.CenterX+rx,cvs.TargetRect.CenterY+ry,8dip,BallColor,True,1dip)
	
	cvs.DrawLine(cvs.TargetRect.CenterX+CatWidth* 0.95 * Sin((Progress-0.02) * 2 * cPI),cvs.TargetRect.CenterY+CatWidth* 0.85 * Cos((Progress-0.02) * 2 * cPI),cvs.TargetRect.CenterX+CatWidth* 0.95 * Sin((Progress+0.02) * 2 * cPI),cvs.TargetRect.CenterY+CatWidth* 0.85 * Cos((Progress+0.02) * 2 * cPI),BallColor,10dip)
'	Dim MaxR As Float = (cvs.TargetRect.Width / 2 - 20dip) / 2
'	Dim r As Float = 10dip + MaxR + MaxR * Sin(Progress * 2 * cPI)
'	For i = 0 To 2
'		Dim alpha As Int = i * 120 + Progress * 360
'		cvs.DrawCircle(cvs.TargetRect.CenterX + r * SinD(alpha), cvs.TargetRect.CenterY + r * CosD(alpha), 7dip, clr, True, 1dip)
'	Next

	cvs.Invalidate
End Sub